.686
.model flat,stdcall
option casemap:none
.xmm

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib


.data
ALIGN 16
   A0  dd 16 dup (-1)  ; x0 is for values
   C0  dd 16 dup (-1)
   A1  dd 16 dup (0)   ; x1 is for carries
   C1  dd 16 dup (0)

   YY  dd -1,-1,-1,-1  ; all 1s  11111111111

   Z0  dd  0           ; hold temp debugging values
   Z1  dd  0
   Z2  dd  0
   Z3  dd  0

   nfx dd 1   ; 1 == SSE2 code,  0 == ALU code
   cnt dd 0
   tot dd 0   ; total SSE2
   toc dd 0   ; total ALU

   jnk dd 0
   dmb dd 1   ; 1 == enable  Debug Messageboxes
       dd 0
       dd 0

   szfmtI db "Mismatch count : %lu",13,10
          db "Total of SSE2 words : %lu",13,10
          db "Total of ALU  words : %lu",0
   szfmtC db "%lu  SSE2 carry",13,10
          db "%lu  ALU  carry",13,10
          db "%lu  Number of dwords",13,10
          db "%lu  Current dword",0
   szC    db "The Caption",0
   szM    db "The Message ",13,10
   szZ    db 256 dup (0)


.code
start:

    mov A0+0, 0    ; result of lowest qword if it was all 1s and 1 added to it
    mov A0+4, 0
    mov C0+0, 0
    mov C0+4, 0
    mov [A1+8], 1  ; the carry was put in the next higher carry qword
    mov [C1+8], 1

    .if nfx >= 1
    movdqa  xmm0, oword ptr [A1 +  0]
    movdqa  xmm1, oword ptr [A1 + 16]
    movdqa  xmm2, oword ptr [A1 + 32]
    movdqa  xmm3, oword ptr [A1 + 48]

    movdqa  xmm7, oword ptr [A0 +  0]
    pcmpeqd xmm7, oword ptr [YY +  0]  ; compare with all 1111  if == 1111, != 0000  per dword
    pshufd  xmm6, xmm7, 0b1h           ; swap dwords  3210 --> 2301
    andpd   xmm6, xmm7                 ; AND 32, 23  AND 10, 01   if same == 1111, diff 0000
    andpd   xmm6, xmm0                 ; C1 + 0
    psrldq  xmm6, 8
    orpd    xmm1, xmm6                 ; oword ptr [A1 + 16]  1a

    movdqa  xmm7, oword ptr [A0 + 16]
    pcmpeqd xmm7, oword ptr [YY +  0]  ; compare with all 1111  if == 1111, != 0000  per dword
    pshufd  xmm6, xmm7, 0b1h           ; swap dwords  3210 --> 2301
    andpd   xmm6, xmm7                 ; AND 32, 23  AND 10, 01   if same == 1111, diff 0000
    andpd   xmm6, xmm1                 ; C1 + 16
    movdqa  xmm5, xmm6
    pslldq  xmm5, 8
    orpd    xmm1, xmm5                 ; oword ptr [A1 + 16]  1b
    andpd   xmm6, xmm1
    psrldq  xmm6, 8
    orpd    xmm2, xmm6                 ; oword ptr [A1 + 32]  2a

    movdqa  xmm7, oword ptr [A0 + 32]
    pcmpeqd xmm7, oword ptr [YY +  0]  ; compare with all 1111  if == 1111, != 0000  per dword
    pshufd  xmm6, xmm7, 0b1h            ; swap dwords  3210 --> 2301
    andpd   xmm6, xmm7                 ; AND 32, 23  AND 10, 01   if same == 1111, diff 0000
    andpd   xmm6, xmm2                 ; C1 + 32
    movdqa  xmm5, xmm6
    pslldq  xmm5, 8
    orpd    xmm2, xmm5                 ; oword ptr [A1 + 32]  2b
    andpd   xmm6, xmm2
    psrldq  xmm6, 8
    orpd    xmm3, xmm6                 ; oword ptr [A1 + 48]  3a

    movdqa  xmm7, oword ptr [A0 + 48]
    pcmpeqd xmm7, oword ptr [YY +  0]  ; compare with all 1111  if == 1111, != 0000  per dword
    pshufd  xmm6, xmm7, 0b1h           ; swap dwords  3210 --> 2301
    andpd   xmm6, xmm7                 ; AND 32, 23  AND 10, 01   if same == 1111, diff 0000
    andpd   xmm6, xmm3                 ; C1 + 48
    pslldq  xmm6, 8
    orpd    xmm3, xmm6                 ; oword ptr [A1 + 48]  3b

    movdqa  oword ptr [A1 +  0], xmm0
    movdqa  oword ptr [A1 + 16], xmm1
    movdqa  oword ptr [A1 + 32], xmm2
    movdqa  oword ptr [A1 + 48], xmm3
    .endif

    .if nfx >= 0

    nop
    mov ecx, 8                                           ; if qword == -1  whatever is in C1+0 is ORed with C1+8
    .if ([C0 + ecx+0] == -1) && ([C0 + ecx+4] == -1)     ;
      mov eax, [C1 + ecx+0]                              ; 0 or 1 doesn't matter
      or  [C1 + ecx+8], eax                              ; and [C1 + ecx+8],1  not needed if C1 is only 1 bit
    .endif
    nop
    add ecx, 8
    .if ([C0 + ecx+0] == -1) && ([C0 + ecx+4] == -1)
      mov eax, [C1 + ecx+0]
      or  [C1 + ecx+8], eax
    .endif
    add ecx, 8
    .if ([C0 + ecx+0] == -1) && ([C0 + ecx+4] == -1)
      mov eax, [C1 + ecx+0]
      or  [C1 + ecx+8], eax
    .endif
    add ecx, 8
    .if ([C0 + ecx+0] == -1) && ([C0 + ecx+4] == -1)
      mov eax, [C1 + ecx+0]
      or  [C1 + ecx+8], eax
    .endif
    add ecx, 8
    .if ([C0 + ecx+0] == -1) && ([C0 + ecx+4] == -1)
      mov eax, [C1 + ecx+0]
      or  [C1 + ecx+8], eax
    .endif
    add ecx, 8
    .if ([C0 + ecx+0] == -1) && ([C0 + ecx+4] == -1)
      mov eax, [C1 + ecx+0]
      or  [C1 + ecx+8], eax
    .endif

    .endif

    mov ecx, 16
    .repeat
       dec ecx
       mov esi, [A1 + ecx*4]  ; A0  SSE2
       mov edi, [C1 + ecx*4]  ; C0  ALU

       mov eax, esi
       and eax, 0ffffh
       add tot, eax
       mov eax, esi
       shr eax, 16
       add tot, eax

       mov eax, edi
       and eax, 0ffffh
       add toc, eax
       mov eax, edi
       shr eax, 16
       add toc, eax

      .if dmb == 1
          mov Z0, esi
          mov Z1, edi
          mov Z2, 16
          mov Z3, ecx
      
          mov jnk, ecx
          invoke wsprintf,ADDR szZ,ADDR szfmtC, Z0, Z1, Z2, Z3    ; debugging code
          invoke MessageBox, NULL, addr szM, addr szC, MB_OK
          mov ecx, jnk
      .endif

       .if esi != edi
          add cnt, 1
       .endif
    .until ecx == 0


   invoke wsprintf,ADDR szZ,ADDR szfmtI,cnt,tot,toc
   invoke MessageBox, NULL, addr szM, addr szC, MB_OK

   invoke ExitProcess, 0
end start